SortResponseControl (Java SE 26 & JDK 26)
Description: declaration: module: java.naming, package: javax.naming.ldap, class: SortResponseControl
Keywords: javax.naming.ldap.SortResponseControl class

# Class SortResponseControl

java.lang.Object
javax.naming.ldap.BasicControl
javax.naming.ldap.SortResponseControl

All Implemented Interfaces:
  `Serializable, Control`

public final class SortResponseControl extends BasicControl
Indicates whether the requested sort of search results was successful or not. When the result code indicates success then the results have been sorted as requested. Otherwise the sort was unsuccessful and additional details regarding the cause of the error may have been provided by the server.

The code sample in `SortControl` shows how this class may be used.

This class implements the LDAPv3 Response Control for server-side sorting as defined in RFC 2891. The control's value has the following ASN.1 definition:

        SortResult ::= SEQUENCE {
           sortResult  ENUMERATED {
               success                   (0), -- results are sorted
               operationsError           (1), -- server internal failure
               timeLimitExceeded         (3), -- timelimit reached before
                                              -- sorting was completed
               strongAuthRequired        (8), -- refused to return sorted
                                              -- results via insecure
                                              -- protocol
               adminLimitExceeded       (11), -- too many matching entries
                                              -- for the server to sort
               noSuchAttribute          (16), -- unrecognized attribute
                                              -- type in sort key
               inappropriateMatching    (18), -- unrecognized or inappro-
                                              -- priate matching rule in
                                              -- sort key
               insufficientAccessRights (50), -- refused to return sorted
                                              -- results to this client
               busy                     (51), -- too busy to process
               unwillingToPerform       (53), -- unable to sort
               other                    (80)
               },
         attributeType [0] AttributeType OPTIONAL }

Since:
  1.5
See Also:
  - `SortControl`
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `OID`
  The server-side sort response control's assigned object identifier is 1.2.840.113556.1.4.474.

  ### Fields declared in class BasicControl

  `criticality, id, value`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `criticality`
  The control's criticality.
  `protected String`
  `id`
  The control's object identifier string.
  `protected byte[]`
  `value`
  The control's ASN.1 BER encoded value.

  ### Fields declared in interface Control

  `CRITICAL, NONCRITICAL`
  Modifier and Type
  Field
  Description
  `static final boolean`
  `CRITICAL`
  Indicates a critical control.
  `static final boolean`
  `NONCRITICAL`
  Indicates a non-critical control.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SortResponseControl(String id, boolean criticality, byte[] value)`
  Constructs a control to indicate the outcome of a sort request.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getAttributeID()`
  Retrieves the ID of the attribute that caused the sort to fail.
  `NamingException`
  `getException()`
  Retrieves the NamingException appropriate for the result code.
  `int`
  `getResultCode()`
  Retrieves the LDAP result code of the sort operation.
  `boolean`
  `isSorted()`
  Determines if the search results have been successfully sorted.

  ### Methods declared in class BasicControl

  `getEncodedValue, getID, isCritical`
  Modifier and Type
  Method
  Description
  `byte[]`
  `getEncodedValue()`
  Retrieves the control's ASN.1 BER encoded value.
  `String`
  `getID()`
  Retrieves the control's object identifier string.
  `boolean`
  `isCritical()`
  Determines the control's criticality.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### OID

    public static final String OID
    The server-side sort response control's assigned object identifier is 1.2.840.113556.1.4.474.
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### SortResponseControl

    public SortResponseControl(String id, boolean criticality, byte[] value) throws IOException
    Constructs a control to indicate the outcome of a sort request.
    Parameters:
      `id` - The control's object identifier string.
      `criticality` - The control's criticality.
      `value` - The control's ASN.1 BER encoded value. It is not cloned - any changes to value will affect the contents of the control.
    Throws:
      `IOException` - if an error is encountered while decoding the control's value.

- ## Method Details

  - ### isSorted

    public boolean isSorted()
    Determines if the search results have been successfully sorted. If an error occurred during sorting a NamingException is thrown.
    Returns:
      true if the search results have been sorted.

  - ### getResultCode

    public int getResultCode()
    Retrieves the LDAP result code of the sort operation.
    Returns:
      The result code. A zero value indicates success.

  - ### getAttributeID

    public String getAttributeID()
    Retrieves the ID of the attribute that caused the sort to fail. Returns null if no ID was returned by the server.
    Returns:
      The possibly null ID of the bad attribute.

  - ### getException

    public NamingException getException()
    Retrieves the NamingException appropriate for the result code.
    Returns:
      A NamingException or null if the result code indicates success.